OGRE-Next: Ogre::GpuProgram Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GpuProgram Class Referenceabstract
Core » Resources

Defines a program which runs on the GPU such as a vertex or fragment program. More...

`#include <OgreGpuProgram.h>`

Inheritance diagram for Ogre::GpuProgram:
[legend]

## Public Member Functions
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| ~GpuProgram () override
virtual GpuProgram * | _getBindingDelegate ()
| Returns the GpuProgram which should be bound to the pipeline.
size_t | calculateSize () const override
| Calculate the size of a resource; this will only be called after 'load'.
virtual GpuProgramParametersSharedPtr | createParameters ()
| Creates a new parameters object compatible with this program definition.
bool | getBuildParametersFromReflection () const
virtual Vector3 | getComputeGroupDimensions () const
| Returns the number of process groups dispatched by this compute program.
virtual const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of named constants.
virtual GpuProgramParametersSharedPtr | getDefaultParameters ()
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual const String & | getLanguage () const
| Returns a string that specifies the language of the gpu programs as specified in a material script.
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual ushort | getNumberOfPosesIncluded () const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
uint8 | getNumClipDistances () const
| Retrieves the number of clip distances. See GpuProgram::setNumClipDistances.
virtual bool | getPassFogStates () const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).
virtual bool | getPassSurfaceAndLightStates () const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).
virtual bool | getPassTransformStates () const
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getSource () const
| Gets the assembler source for this program.
virtual const String & | getSourceFile () const
| Gets the name of the file used as source for this program.
virtual const String & | getSyntaxCode () const
| Gets the syntax code for this program e.g.
virtual GpuProgramType | getType () const
| Get the program type.
virtual bool | hasCompileError () const
| Did this program encounter a compile error when loading?
virtual bool | hasDefaultParameters () const
| Returns true if default parameters have been set up.
virtual bool | isAdjacencyInfoRequired () const
| Returns whether this geometry program requires adjacency information from the input primitives.
virtual bool | isMorphAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform morph animation.
virtual bool | isPoseAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform pose animation.
virtual bool | isSkeletalAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
virtual bool | isSupported () const
| Returns whether this program can be supported on the current renderer and hardware.
virtual bool | isVertexTextureFetchRequired () const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual bool | isVpAndRtArrayIndexFromAnyShaderRequired () const
| Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | resetCompileError ()
| Reset a compile error if it occurred, allowing the load to be retried.
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives.
virtual void | setAutoReflectArrayBindingsInRootLayout (bool bReflectArrayRootLayouts)
| Set to true to reflects the shader looking for array bindings (e.g.
void | setBuildParametersFromReflection (bool buildParams)
virtual void | setComputeGroupDimensions (Vector3 dimensions)
| Sets the number of process groups dispatched by this compute program.
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
void | setNumClipDistances (const uint8 numClipDistances)
| Sets the number of clip distances this shader uses.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
void | setPrefabRootLayout (const PrefabRootLayout::PrefabRootLayout &prefab)
| Sets a prefab root layout, mostly meant for low level materials (e.g.
virtual void | setReplaceVersionMacro (bool bReplace)
| When true:
virtual void | setRootLayout (GpuProgramType t, const RootLayout &rootLayout)
| Sets a RootLayout programmatically, thus the shader source won't be parsed looking for one We will call validate().
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual void | setSource (const String &source, const String &debugFilename)
| Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual void | setUniformBlockBinding (const char *blockName, uint32 bindingSlot)
| For GL only. Program must be bound when calling.
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | setVpAndRtArrayIndexFromAnyShaderRequired (bool r)
| Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | unsetRootLayout ()
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | touch ()
| 'Touches' the resource to indicate it has been used.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX

## Detailed Description

Defines a program which runs on the GPU such as a vertex or fragment program.

Remarks
  This class defines the low-level program in assembler code, the sort used to directly assemble into machine instructions for the GPU to execute. By nature, this means that the assembler source is rendersystem specific, which is why this is an abstract class - real instances are created through the RenderSystem. If you wish to use higher level shading languages like HLSL and Cg, you need to use the HighLevelGpuProgram class instead.

## Constructor & Destructor Documentation

## ◆ GpuProgram()

Ogre::GpuProgram::GpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Referenced by _getBindingDelegate(), and Ogre::HighLevelGpuProgram::_getBindingDelegate().

## ◆ ~GpuProgram()

Ogre::GpuProgram::~GpuProgram | ( |  | ) |
| inlineoverride

## Member Function Documentation

## ◆ _getBindingDelegate()

virtual GpuProgram * Ogre::GpuProgram::_getBindingDelegate | ( |  | ) |
| inlinevirtual

Returns the GpuProgram which should be bound to the pipeline.

Remarks
  This method is simply to allow some subclasses of GpuProgram to delegate the program which is bound to the pipeline to a delegate, if required.

Reimplemented in Ogre::GLSLShader, Ogre::HighLevelGpuProgram, and Ogre::UnifiedHighLevelGpuProgram.

References GpuProgram().

## ◆ calculateSize()

size_t Ogre::GpuProgram::calculateSize | ( |  | ) | const
| overridevirtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::Resource.

Reimplemented in Ogre::HighLevelGpuProgram, and Ogre::UnifiedHighLevelGpuProgram.

## ◆ createParameters()

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::createParameters | ( |  | ) |
| virtual

Creates a new parameters object compatible with this program definition.

Remarks
  It is recommended that you use this method of creating parameters objects rather than going direct to GpuProgramManager, because this method will populate any implementation-specific extras (like named parameters) where they are appropriate.

Reimplemented in Ogre::D3D11HLSLProgram, Ogre::GLSLShader, Ogre::HighLevelGpuProgram, Ogre::MetalProgram, Ogre::UnifiedHighLevelGpuProgram, and Ogre::VulkanProgram.

## ◆ getBuildParametersFromReflection()

bool Ogre::GpuProgram::getBuildParametersFromReflection | ( |  | ) | const
| inline

## ◆ getComputeGroupDimensions()

virtual Vector3 Ogre::GpuProgram::getComputeGroupDimensions | ( |  | ) | const
| inlinevirtual

Returns the number of process groups dispatched by this compute program.

## ◆ getConstantDefinitions()

virtual const GpuNamedConstants & Ogre::GpuProgram::getConstantDefinitions | ( |  | ) | const
| inlinevirtual

Get the full list of named constants.

Note
  Only available if this parameters object has named parameters, which means either a high-level program which loads them, or a low-level program which has them specified manually.

Reimplemented in Ogre::HighLevelGpuProgram.

## ◆ getDefaultParameters()

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::getDefaultParameters | ( |  | ) |
| virtual

Get a reference to the default parameters which are to be used for all uses of this program.

Remarks
  A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getLanguage()

virtual const String & Ogre::GpuProgram::getLanguage | ( |  | ) | const
| virtual

Returns a string that specifies the language of the gpu programs as specified in a material script.

ie: asm, cg, hlsl, glsl

Reimplemented in Ogre::D3D11HLSLProgram, Ogre::GLSLShader, Ogre::MetalProgram, Ogre::UnifiedHighLevelGpuProgram, and Ogre::VulkanProgram.

## ◆ getManualNamedConstantsFile()

virtual const String & Ogre::GpuProgram::getManualNamedConstantsFile | ( |  | ) | const
| inlinevirtual

Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

## ◆ getNumberOfPosesIncluded()

virtual ushort Ogre::GpuProgram::getNumberOfPosesIncluded | ( |  | ) | const
| inlinevirtual

Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getNumClipDistances()

uint8 Ogre::GpuProgram::getNumClipDistances | ( |  | ) | const
| inline

Retrieves the number of clip distances. See GpuProgram::setNumClipDistances.

## ◆ getPassFogStates()

virtual bool Ogre::GpuProgram::getPassFogStates | ( |  | ) | const
| inlinevirtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).

Remarks
  On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented in Ogre::GLSLShader, Ogre::MetalProgram, Ogre::UnifiedHighLevelGpuProgram, and Ogre::VulkanProgram.

## ◆ getPassSurfaceAndLightStates()

virtual bool Ogre::GpuProgram::getPassSurfaceAndLightStates | ( |  | ) | const
| inlinevirtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).

Remarks
  Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented in Ogre::GLSLShader, Ogre::MetalProgram, Ogre::UnifiedHighLevelGpuProgram, and Ogre::VulkanProgram.

## ◆ getPassTransformStates()

virtual bool Ogre::GpuProgram::getPassTransformStates | ( |  | ) | const
| inlinevirtual

Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.

Remarks
  Most vertex programs do not need fixed-function transform information, however GLSL shaders can refer to this state so enable this option

Reimplemented in Ogre::GLSLShader, Ogre::MetalProgram, Ogre::UnifiedHighLevelGpuProgram, and Ogre::VulkanProgram.

## ◆ getSource()

virtual const String & Ogre::GpuProgram::getSource | ( |  | ) | const
| inlinevirtual

Gets the assembler source for this program.

## ◆ getSourceFile()

virtual const String & Ogre::GpuProgram::getSourceFile | ( |  | ) | const
| inlinevirtual

Gets the name of the file used as source for this program.

## ◆ getSyntaxCode()

virtual const String & Ogre::GpuProgram::getSyntaxCode | ( |  | ) | const
| inlinevirtual

Gets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ getType()

virtual GpuProgramType Ogre::GpuProgram::getType | ( |  | ) | const
| inlinevirtual

Get the program type.

## ◆ hasCompileError()

virtual bool Ogre::GpuProgram::hasCompileError | ( |  | ) | const
| inlinevirtual

Did this program encounter a compile error when loading?

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ hasDefaultParameters()

virtual bool Ogre::GpuProgram::hasDefaultParameters | ( |  | ) | const
| inlinevirtual

Returns true if default parameters have been set up.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isAdjacencyInfoRequired()

virtual bool Ogre::GpuProgram::isAdjacencyInfoRequired | ( |  | ) | const
| inlinevirtual

Returns whether this geometry program requires adjacency information from the input primitives.

## ◆ isMorphAnimationIncluded()

virtual bool Ogre::GpuProgram::isMorphAnimationIncluded | ( |  | ) | const
| inlinevirtual

Returns whether a vertex program includes the required instructions to perform morph animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isPoseAnimationIncluded()

virtual bool Ogre::GpuProgram::isPoseAnimationIncluded | ( |  | ) | const
| inlinevirtual

Returns whether a vertex program includes the required instructions to perform pose animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isSkeletalAnimationIncluded()

virtual bool Ogre::GpuProgram::isSkeletalAnimationIncluded | ( |  | ) | const
| inlinevirtual

Returns whether a vertex program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isSupported()

virtual bool Ogre::GpuProgram::isSupported | ( |  | ) | const
| virtual

Returns whether this program can be supported on the current renderer and hardware.

Reimplemented in Ogre::D3D11HLSLProgram, and Ogre::UnifiedHighLevelGpuProgram.

## ◆ isVertexTextureFetchRequired()

virtual bool Ogre::GpuProgram::isVertexTextureFetchRequired | ( |  | ) | const
| inlinevirtual

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isVpAndRtArrayIndexFromAnyShaderRequired()

virtual bool Ogre::GpuProgram::isVpAndRtArrayIndexFromAnyShaderRequired | ( |  | ) | const
| inlinevirtual

Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.

## ◆ resetCompileError()

virtual void Ogre::GpuProgram::resetCompileError | ( |  | ) |
| inlinevirtual

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setAdjacencyInfoRequired()

virtual void Ogre::GpuProgram::setAdjacencyInfoRequired | ( | bool | r | ) |
| inlinevirtual

Sets whether this geometry program requires adjacency information from the input primitives.

## ◆ setAutoReflectArrayBindingsInRootLayout()

virtual void Ogre::GpuProgram::setAutoReflectArrayBindingsInRootLayout | ( | bool | bReflectArrayRootLayouts | ) |
| virtual

Set to true to reflects the shader looking for array bindings (e.g.

uniform texture2D myTex[123]) to patch the Root Layout

Parameters

  bReflectArrayRootLayouts | When true (default), reflect the shader to see if the RootLayout needs patching to include array bindings

When false, we assume the RootLayout doesn't need patching and array bindings are correct. Failure to do this right may result in shader compiler errors OR everything appears fine but Vulkan Validation Layers detect it

In debug builds we will validate and reflect anyway to detect wrong usage

Reimplemented in Ogre::VulkanProgram.

## ◆ setBuildParametersFromReflection()

void Ogre::GpuProgram::setBuildParametersFromReflection | ( | bool | buildParams | ) |
| inline

## ◆ setComputeGroupDimensions()

virtual void Ogre::GpuProgram::setComputeGroupDimensions | ( | Vector3 | dimensions | ) |
| inlinevirtual

Sets the number of process groups dispatched by this compute program.

## ◆ setManualNamedConstants()

virtual void Ogre::GpuProgram::setManualNamedConstants | ( | const GpuNamedConstants & | namedConstants | ) |
| virtual

Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.

Remarks
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source.

See also
  setManualNamedConstantsFile

## ◆ setManualNamedConstantsFile()

virtual void Ogre::GpuProgram::setManualNamedConstantsFile | ( | const String & | paramDefFile | ) |
| virtual

Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

Remarks
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source. This method will make a low-level program search in the resource group of the program for the named file from which to load parameter names from. The file must be in the format produced by GpuNamedConstants::save.

## ◆ setMorphAnimationIncluded()

virtual void Ogre::GpuProgram::setMorphAnimationIncluded | ( | bool | included | ) |
| inlinevirtual

Sets whether a vertex program includes the required instructions to perform morph animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

## ◆ setNumClipDistances()

void Ogre::GpuProgram::setNumClipDistances | ( | const uint8 | numClipDistances | ) |

Sets the number of clip distances this shader uses.

Only valid for vertex shaders. Default is 0

## ◆ setPoseAnimationIncluded()

virtual void Ogre::GpuProgram::setPoseAnimationIncluded | ( | ushort | poseCount | ) |
| inlinevirtual

Sets whether a vertex program includes the required instructions to perform pose animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Parameters

  poseCount | The number of simultaneous poses the program can blend

## ◆ setPrefabRootLayout()

void Ogre::GpuProgram::setPrefabRootLayout | ( | const PrefabRootLayout::PrefabRootLayout & | prefab | ) |

Sets a prefab root layout, mostly meant for low level materials (e.g.

postprocessing) so that users don't have to deal with Root Layouts unless they exceed defaults

Each prefab higher root layout supports more features but consumes more memory

## ◆ setReplaceVersionMacro()

virtual void Ogre::GpuProgram::setReplaceVersionMacro | ( | bool | bReplace | ) |
| virtual

When true:

On OpenGL: Finds the first occurrence of "ogre_glsl_ver_xxx" and only keeps "xxx" e.g. ogre_glsl_ver_330 becomes 330, ogre_glsl_ver_430 becomes 430

On Vulkan: Finds the first occurrence of "ogre_glsl_ver_xxx" and replaces it with "450"

This is disabled by default because we must scan the entire source and it's just wasted cycles when using Hlms.

However it is enabled by default on low level materials, because their source length tends to be very short and it is extremely useful/practical there

Parameters

  bReplace |

Reimplemented in Ogre::GLSLShader, and Ogre::VulkanProgram.

## ◆ setRootLayout()

virtual void Ogre::GpuProgram::setRootLayout | ( | GpuProgramType | t,
|  | const RootLayout & | rootLayout )
| virtual

Sets a RootLayout programmatically, thus the shader source won't be parsed looking for one We will call validate().

Do not alter the type after calling this function.

This setting will be cleared if the program gets unloaded

Reimplemented in Ogre::VulkanProgram.

## ◆ setSkeletalAnimationIncluded()

virtual void Ogre::GpuProgram::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inlinevirtual

Sets whether a vertex program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ setSource() [1/2]

virtual void Ogre::GpuProgram::setSource | ( | const String & | source | ) |
| virtual

Sets the source assembly for this program from an in-memory string.

Remarks
  Setting this will have no effect until you (re)load the program.

## ◆ setSource() [2/2]

virtual void Ogre::GpuProgram::setSource | ( | const String & | source,
|  | const String & | debugFilename )
| virtual

Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.

Visual Studio Graphics Debugger)

Parameters

  source | Shader source code
  debugFilename | Optional Path to this file. Can be left blank.

## ◆ setSourceFile()

virtual void Ogre::GpuProgram::setSourceFile | ( | const String & | filename | ) |
| virtual

Sets the filename of the source assembly for this program.

Remarks
  Setting this will have no effect until you (re)load the program.

## ◆ setSyntaxCode()

virtual void Ogre::GpuProgram::setSyntaxCode | ( | const String & | syntax | ) |
| virtual

Sets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ setType()

virtual void Ogre::GpuProgram::setType | ( | GpuProgramType | t | ) |
| virtual

Set the program type (only valid before load).

## ◆ setUniformBlockBinding()

virtual void Ogre::GpuProgram::setUniformBlockBinding | ( | const char * | blockName,
|  | uint32 | bindingSlot )
| inlinevirtual

For GL only. Program must be bound when calling.

## ◆ setVertexTextureFetchRequired()

virtual void Ogre::GpuProgram::setVertexTextureFetchRequired | ( | bool | r | ) |
| inlinevirtual

Sets whether this vertex program requires support for vertex texture fetch from the hardware.

## ◆ setVpAndRtArrayIndexFromAnyShaderRequired()

virtual void Ogre::GpuProgram::setVpAndRtArrayIndexFromAnyShaderRequired | ( | bool | r | ) |
| inlinevirtual

Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.

## ◆ unsetRootLayout()

virtual void Ogre::GpuProgram::unsetRootLayout | ( |  | ) |
| virtual

Reimplemented in Ogre::VulkanProgram.

The documentation for this class was generated from the following file:

- OgreGpuProgram.h